/* $Id: omega_science.h,v 1.2 2011/07/22 09:57:41 agabasch Exp $
 *
 * This file is part of the oc Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: agabasch $
 * $Date: 2011/07/22 09:57:41 $
 * $Revision: 1.2 $
 * $Name: omega-1_0_2 $
 */

#ifndef OC_SCIENCE_H
#define OC_SCIENCE_H

#include <cpl.h>
#include "omega_fits.h"

cpl_image *omega_reduce_science(const cpl_frame *stdframe, cpl_image *mask_img,
							cpl_parameterlist *pars, int ext);

omega_fits *omega_jitter_process(omega_fits *scifits, const cpl_image *mbias, const cpl_image *mflat,
						const cpl_image *bpm, const cpl_table *photom, const cpl_frame *usnoa2,
						const cpl_image *illum,const cpl_image *fringes, const cpl_image *nsky, double * zeropoint_final,
						cpl_parameterlist *pars, int ext);

cpl_image *omega_reduce_science(const cpl_frame *stdframe, cpl_image *mask_img,
							cpl_parameterlist *pars, int ext);

int omega_science_save_stare(cpl_image *img, cpl_table *tbl, cpl_frameset *set,
		cpl_parameterlist *pars,cpl_propertylist *xlist, const char *procatg,const char *name,
		cpl_propertylist *qclist,cpl_frame *inherit,cpl_frame *product_frame);

int omega_science_save_jitter(omega_fits *scifits,cpl_frameset *set, cpl_parameterlist *pars,
							cpl_propertylist *qclist, const char *jitter_name,
							cpl_frame *product_frame, cpl_frame *inherit, const int isfirst);

int omega_science_save_stack(cpl_image *img, cpl_frameset *set, cpl_parameterlist *pars,
		cpl_propertylist *alist, cpl_propertylist *qclist, const char *outname,
		cpl_frame *product_frame, const int isfirst);

int omega_science_save_conf(cpl_image *img, cpl_frameset *set, cpl_parameterlist *pars,
		const cpl_propertylist *alist, cpl_propertylist *qclist, const char *outname,
		cpl_frame *product_frame, const int isfirst);

int omega_science_save_table(cpl_table *tbl, cpl_frameset *set, cpl_parameterlist *pars,
		cpl_propertylist *alist, cpl_propertylist *qclist, const char *outname,
		cpl_frame *product_frame, const int isfirst);

/*
 * OLD prototypes. To be reviewed and deprecated
 */
int reduce_sci_direct(cpl_parameterlist *, cpl_frameset *);
int reduce_sci_dither(cpl_parameterlist *, cpl_frameset *);
int reduce_sci_jitter(cpl_parameterlist *, cpl_frameset *);

/*Input Frames are:
science, mbias, mflat, fringes, nsky, illum, maskimg, pars
*/
/*cpl_image *make_reduced(cpl_frame *,cpl_frame *, cpl_frame *, cpl_frame *,
				  		cpl_frame *, cpl_frame *, cpl_frame *,
				  		cpl_mask *, cpl_parameterlist *);*/

cpl_image *make_reduced(cpl_frame *,cpl_frame *, cpl_frame *, cpl_frame *,
				  		cpl_frame *, cpl_frame *,cpl_image *, cpl_parameterlist *);


cpl_imagelist *make_reduced_jitter(cpl_imagelist *,cpl_frame *,cpl_frame *,
				  			cpl_frame *, cpl_frame *, cpl_frame *,
				  			cpl_imagelist *, cpl_parameterlist *);

/*For tests using file oc_sci_jitter_test.c*/
int reduce_sci_jitter_test(cpl_parameterlist *, cpl_frameset *);


#endif
